﻿Imports Syncfusion.PivotAnalysis.Base
Imports Syncfusion.Windows.Forms.Grid
Imports System.Reflection
Imports System.Windows.Forms


Public Class Form1
    Private Sub OrdersBindingNavigatorSaveItem_Click(sender As Object, e As EventArgs) Handles OrdersBindingNavigatorSaveItem.Click
        Me.Validate()
        Me.OrdersBindingSource.EndEdit()
        Me.TableAdapterManager.UpdateAll(Me.NORTHWNDDataSet)

    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'TODO: This line of code loads data into the 'NORTHWNDDataSet.Orders' table. You can move, or remove it, as needed.
        Me.OrdersTableAdapter.Fill(Me.NORTHWNDDataSet.Orders)
        Me.PivotGridControl1.ItemSource = Me.OrdersBindingSource
        PivotGridControl1.PivotRows.Add(New PivotItem With {.FieldMappingName = "ShipName", .FieldHeader = "Name", .TotalHeader = "Total", .AllowFilter = True, .AllowSort = True})
        PivotGridControl1.PivotRows.Add(New PivotItem With {.FieldMappingName = "OrderID", .FieldHeader = "Order", .TotalHeader = "Total", .AllowFilter = True, .AllowSort = True})
        PivotGridControl1.PivotColumns.Add(New PivotItem With {.FieldMappingName = "ShipRegion", .TotalHeader = "Total"})
        PivotGridControl1.PivotColumns.Add(New PivotItem With {.FieldMappingName = "ShipCity", .TotalHeader = "Total"})
        PivotGridControl1.PivotRows.Add(New PivotItem With {.FieldMappingName = "ShipCountry", .TotalHeader = "Total"})
        ' PivotGridControl1.PivotColumns.Add(New PivotItem With {.FieldMappingName = "EmployeeID", .TotalHeader = "Total"})
        PivotGridControl1.PivotCalculations.Add(New PivotComputationInfo With {.FieldName = "Freight", .Format = "#, ##0", .SummaryType = SummaryType.Count})

        Me.PivotGridControl1.ShowPivotTableFieldList = True
        Me.PivotGridControl1.ShowGroupBar = False
        Me.PivotGridControl1.EnableValueEditing = True
        Me.PivotGridControl1.TableControl.AllowColumnResizeUsingCellBoundaries = True

        'to hide the second column.
        PivotGridControl1.TableModel.ColWidths(2) = 0

        AddHandler PivotGridControl1.TableControl.GroupDropArea.ColWidthsChanged, AddressOf GroupDropArea_ColWidthsChanged
        'AddHandler Me.PivotGridControl1.TableModel.ColWidthsChanged, AddressOf TableModel_ColWidthsChanged
        'AddHandler PivotGridControl1.TableControl.CurrentCellEditingComplete, AddressOf Me.TableControl_CurrentCellEditingComplete
    End Sub

    'To maintain the column width value to 0 after performing any drag and drop operation.
    Private Sub GroupDropArea_ColWidthsChanged(ByVal sender As Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridRowColSizeChangedEventArgs)
        PivotGridControl1.TableModel.ColWidths(2) = 0
    End Sub

    Dim value As String
    Dim cellInfo As PivotCellInfo

    Private Sub TableControl_CurrentCellEditingComplete(ByVal sender As Object, ByVal e As EventArgs)
        value = PivotGridControl1.PivotEngine(Me.PivotGridControl1.TableControl.CurrentCell.RowIndex - 1, 0).Key.ToString()
        cellInfo = PivotGridControl1.PivotEngine(Me.PivotGridControl1.TableControl.CurrentCell.RowIndex - 1, Me.PivotGridControl1.TableControl.CurrentCell.ColIndex - 1)
        value = PivotGridControl1.PivotEngine(Me.PivotGridControl1.TableControl.CurrentCell.RowIndex - 1, Me.PivotGridControl1.TableControl.CurrentCell.ColIndex - 1).FormattedText
        If System.Text.RegularExpressions.Regex.IsMatch(value, "\\d+") Then

        End If
    End Sub

    Private Sub TableModel_ColWidthsChanged(ByVal sender As Object, ByVal e As GridRowColSizeChangedEventArgs)
        'Resize the elements in row grouping bar.
        Dim emptySpaceWidth As Integer = 6
        Dim index As Integer
        For j As Integer = 1 To 2 * (PivotGridControl1.TableControl.PivotRows.Count)
            If j Mod 2 = 0 AndAlso PivotGridControl1.TableControl.RowGroupDropArea IsNot Nothing AndAlso PivotGridControl1.TableControl.RowGroupDropArea.Model IsNot Nothing Then
                index = j / 2
                PivotGridControl1.TableControl.RowGroupDropArea.Model.ColWidths(j) = PivotGridControl1.TableModel.ColWidths(index) - (emptySpaceWidth + emptySpaceWidth / 2)
            End If
        Next
    End Sub
End Class